import "WalmPlugins.BandOfFarmers.UTF";
import "WalmPlugins.BandOfFarmers.TabButton";
import "WalmPlugins.BandOfFarmers.PlayerGoldNode";
import "WalmPlugins.BandOfFarmers.CraftGlobalNode";
import "WalmPlugins.BandOfFarmers.CraftNode";
import "WalmPlugins.BandOfFarmers.PlayerMessage";
import "WalmPlugins.BandOfFarmers.PlayerStuffNode";
import "WalmPlugins.BandOfFarmers.TokenSearchNode";



BandOfFarmers = class( Turbine.UI.Lotro.Window );

function BandOfFarmers:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( 343, 300 );
	self:SetPosition( settings.main_x, settings.main_y);
	self:SetVisible(false);
	
	self:SetText( "BOF - Band Of Farmers" );	
	
	self.playersData = DataLoad(Turbine.DataScope.Account, "BandOfFarmers_characters", ptr);
	if(self.playersData == nil) then
		self.playersData = {};
	end	
	

	-- Build GUI and logicals
	self:CreateComponents(self.playersData);
	
	self.PositionChanged = function(sender, args)
		settings.main_x, settings.main_y = self:GetPosition();
		Savesettings();
	end	
	
	self.Closed = function(sender, args)
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>".._("CLOSENOTIF").."</rgb>");
		self:Stop();
	end
	
	function ptr(sender, args)
		--
	end

	
	if(settings.updateAtLaunchAndUnload) then
		self:UpdateLocalPlayerData();
	end
	--self:ReloadTreeView(settings.displayedTab);
end

function BandOfFarmers:CreateComponents(players)
	self:CreateTreeViewComponents();
	self:CreateHeaderComponents();
	
	local left = 12;
	local space = 3;
	local goldTab = TabButton(_("GOLD"), true);
	goldTab:SetParent(self);
	goldTab:SetPosition( left, 38 );
	local craftTab = TabButton(_("CRAFT"), true);
	craftTab:SetParent(self);
	craftTab:SetPosition( left+1*(60+space), 38 );
	local tokensTab = TabButton(_("TOKENS"), true);
	tokensTab:SetParent(self);
	tokensTab:SetPosition( left+2*(60+space), 38 );	
	local memoTab = TabButton(_("MEMO"), true);
	memoTab:SetParent(self);
	memoTab:SetPosition( left+3*(60+space), 38 );
	-- local stuffTab = TabButton("Stuff", true);
	-- stuffTab:SetParent(self);
	-- stuffTab:SetPosition( left+3*(60+space), 38 );	
	
	goldTab.MouseClick = function()
		goldTab:SetSelected(true);
		craftTab:SetSelected(false);
		memoTab:SetSelected(false);
		-- stuffTab:SetSelected(false);
		tokensTab:SetSelected(false);
		self:ReloadTreeView(1);
	end	
	craftTab.MouseClick = function()
		goldTab:SetSelected(false);
		craftTab:SetSelected(true);
		memoTab:SetSelected(false);
		-- stuffTab:SetSelected(false);
		tokensTab:SetSelected(false);
		self:ReloadTreeView(2);
	end	
	memoTab.MouseClick = function()
		goldTab:SetSelected(false);
		craftTab:SetSelected(false);
		memoTab:SetSelected(true);
		-- stuffTab:SetSelected(false);
		tokensTab:SetSelected(false);
		self:ReloadTreeView(3);
	end
	-- stuffTab.MouseClick = function()
		-- goldTab:SetSelected(false);
		-- craftTab:SetSelected(false);
		-- memoTab:SetSelected(false);
		-- stuffTab:SetSelected(true);
		-- tokensTab:SetSelected(false);
		-- self:ReloadTreeView(4);
	-- end	
	tokensTab.MouseClick = function()
		goldTab:SetSelected(false);
		craftTab:SetSelected(false);
		memoTab:SetSelected(false);
		-- stuffTab:SetSelected(false);
		tokensTab:SetSelected(true);
		self:ReloadTreeView(5);
	end	
	if(settings.displayedTab==nil) then settings.displayedTab=1; end
	goldTab:SetSelected(settings.displayedTab==1);
	craftTab:SetSelected(settings.displayedTab==2);
	memoTab:SetSelected(settings.displayedTab==3);
	-- stuffTab:SetSelected(settings.displayedTab==4);
	tokensTab:SetSelected(settings.displayedTab==5);
	self:ReloadTreeView(settings.displayedTab);
end


function BandOfFarmers:ReloadTreeView(id, players)
	if(players==nil) then players = self.playersData; end;
	-- if(id == self.showingId) then
		-- self:UpdateTreeViewData(nil);
	-- else
		self.treeView:GetNodes():Clear();
		
		if(id==1 or id==nil) then
			local totalPlayer = {}; 
			totalPlayer.name = _("TREEGOLD");
			totalPlayer.globalgold = true;
			totalPlayer.data = {};
			totalPlayer.data.gold = 0;
			local totalgold = 0;
			for i=1 , table.getn(self.playersData) , 1 do
				totalPlayer.data.gold = totalPlayer.data.gold + self.playersData[i].data.gold;
			end			
			local totalnode = PlayerGoldNode(totalPlayer, true);
			self.treeView:GetNodes():Add(totalnode);
			
			table.sort(self.playersData, sortdatabygold);
			for i=1 , table.getn(self.playersData) , 1 do
				local playerData = self.playersData[i];
				local node = PlayerGoldNode(playerData, playerData.name==self.localPlayerName);
				
				self.treeView:GetNodes():Add(node);
			end
			id = 1;
		elseif id == 2 then
			local globalCraftNode = CraftGlobalNode(self.playersData);
			self.treeView:GetNodes():Add(globalCraftNode);
			
			for i=1 , table.getn(self.playersData) , 1 do
				local playerData = self.playersData[i];
				if table.getn(playerData.data.profession)>0 then
					local node = CraftNode(playerData, playerData.name==self.localPlayerName);
					self.treeView:GetNodes():Add(node);
				end
			end
		elseif id == 3 then
			for i=1 , table.getn(self.playersData) , 1 do
				local playerData = self.playersData[i];
				local node = PlayerMessage(playerData, self, playerData.name==self.localPlayerName);
				self.treeView:GetNodes():Add(node);
			end
		elseif id==4 then
			for i=1 , table.getn(self.playersData) , 1 do
				if(self.playersData[i].stuff ~= nil) then
					local node = PlayerStuffNode(self.playersData[1]);
					self.treeView:GetNodes():Add(node);
				end
			end		
		elseif id==5 then
			local searchNode = TokenSearchNode(self.playersData, self.treeView);
			self.treeView:GetNodes():Add(searchNode);
		
		end
		
		self.showingId = id;
		settings.displayedTab = id;
		Savesettings();
	-- end

end

function BandOfFarmers:UpdateTreeViewData(id)
	-- FIXME
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>TODO : Mettre à jour les données</rgb>");
	if id == nil then
		return 0;
	end
	
	for i=1 , self.treeView:GetNodes():GetCount() , 1 do
		local node = self.treeView:GetNodes():Get(i);
		if(node:GetPlayer()~= nil and node:GetPlayer().name == id.name) then
			node:UpdateNodeData(id);
		elseif(node:GetPlayer()~= nil and node:GetPlayer().globalgold == true) then
			local gold = 0;
			for i=1 , table.getn(self.playersData) , 1 do
				gold = gold + self.playersData[i].data.gold;
			end
			node:GetPlayer().data.gold = gold;
		end
	end
end


function BandOfFarmers:CreateTreeViewComponents()
	local topTreeView = 62;
	self.treeView = Turbine.UI.TreeView();
    self.treeView:SetParent( self );
    self.treeView:SetPosition( 10, topTreeView );
    self.treeView:SetSize( self:GetWidth()-20, 200 );
    self.treeView:SetIndentationWidth( 15 );
	--self.treeView:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	local treeViewScrollBar = Turbine.UI.Lotro.ScrollBar();
    treeViewScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    treeViewScrollBar:SetParent( self );
    treeViewScrollBar:SetPosition(self:GetWidth()-15, topTreeView );
    treeViewScrollBar:SetSize( 10, self.treeView:GetHeight() );
	self.treeView:SetVerticalScrollBar( treeViewScrollBar );

	local upperSep = Turbine.UI.Control();
	upperSep:SetParent( self );
	upperSep:SetSize( self:GetWidth()-8 , 2 );
	upperSep:SetPosition( 4, topTreeView-2 );	
	upperSep:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
	upperSep:SetZOrder(99);
	local lowerSep = Turbine.UI.Control();
	lowerSep:SetParent( self );
	lowerSep:SetSize( self:GetWidth()-8 , 2 );
	lowerSep:SetPosition( 4, treeViewScrollBar:GetTop()+treeViewScrollBar:GetHeight() );	
	lowerSep:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
	lowerSep:SetZOrder(99);
end

function BandOfFarmers:CreateHeaderComponents()
	local reloadButton = Turbine.UI.Lotro.Button();
	reloadButton:SetParent( self );
	reloadButton:SetText(_("UPDATEDATA"));
	reloadButton:SetSize( 100 , 18 );
	--reloadButton:SetPosition( self:GetWidth()-100, self:GetHeight()-30 );	
	reloadButton:SetPosition( 215, 268 );	
	--reloadButton:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
	--reloadButton:SetZOrder(99);
	--reloadButton:SetBackground("WalmPlugins/BandOfFarmers/icon_rotation_z.tga");
	--reloadButton:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	reloadButton.Click = function()
		self:UpdateLocalPlayerData();
	end
end

function BandOfFarmers:UpdateLocalPlayerData()
	local localPlayerData = self:GetLocalPlayerData();
	if localPlayerData == nil then
		return 0;
	end
	local found = 0;
	for i=1 , table.getn(self.playersData) , 1 do
		local pData = self.playersData[i];
		if(pData.name == localPlayerData.name) then
			local previousMessage = self.playersData[i].message;
			self.playersData[i] = localPlayerData;
			self.playersData[i].message = previousMessage;
			found = i;
		end
	end
	if(found == 0) then
		table.insert(self.playersData, localPlayerData);
		self:ReloadTreeView(self.showingId);
	else
		--self:UpdateTreeViewData(self.playersData[found]);
		self:ReloadTreeView(self.showingId);
	end
	DataSave(Turbine.DataScope.Account, "BandOfFarmers_characters", self.playersData);
end

function BandOfFarmers:GetLocalPlayerData()
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player == nil) then
		return nil;
	end
	self.localPlayerName = player:GetName();
	if(self.playerAttributes == nil ) then
		self.playerAttributes = player:GetAttributes();
	end
	local result = {};
	result.name = player:GetName();
	result.data = {}
	result.data.level = player:GetLevel(); -- LevelChanged(sender, args)
	result.data.playerClass = player:GetClass();
	
	local z=player:GetClass();
	if(z~=172 and z~=214 and z~=40 and z~=23 and z~=194 and z~=193 and z~=185 and z~=162 and z~=31 and z~=24) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>".._("ERRCLASS").."</rgb>");
		return nil;
	end
	Turbine.Shell.WriteLine("<rgb=#FF5CCD>BOF - Band of Farmers : ".._("DATAOF")..result.name.._("UPDATED").."</rgb>");
	
	result.data.gold = self.playerAttributes:GetMoney();
	
	result.data.profession = {};
	result.data.profession.vocation = self.playerAttributes:GetVocation();
	local profId = 1;
	for i=1, 12 , 1 do
		local job = self.playerAttributes:GetProfessionInfo(i);
		if(job ~= nil) then
			result.data.profession[profId] = {};
			result.data.profession[profId].name = job:GetName();
			result.data.profession[profId].level = job:GetProficiencyLevel();
			result.data.profession[profId].levelXP = ""..job:GetProficiencyExperience().."/"..job:GetProficiencyExperienceTarget();
			result.data.profession[profId].mastery = job:GetMasteryLevel();
			result.data.profession[profId].masteryXP = ""..job:GetMasteryExperience().."/"..job:GetMasteryExperienceTarget();
			
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Profession trouvée : ".. result.data.profession[profId].name ..": niveau " ..result.data.profession[profId].level.." | guilde : ".. result.data.profession[profId].mastery .."  </rgb>");
			profId = profId + 1;
		end
	end
	
	result.stuff = {};
	result.stuff[1] = player:GetEquipment():GetItem(1);
	
	local wallet = player:GetWallet();
	result.data.wallet = {};
	for i=1 , wallet:GetSize() , 1 do
		local walletItem = wallet:GetItem(i);
		if(walletItem:IsAccountItem()==false and walletItem:GetQuantity()>0) then
		--if(walletItem:GetQuantity()>0) then
			local wItem = {};
			wItem.name = walletItem:GetName();
			wItem.quantity = walletItem:GetQuantity();
			wItem.maxQuantity = walletItem:GetMaxQuantity();
			wItem.description = walletItem:GetDescription();
			wItem.image = walletItem:GetImage();
			wItem.smallImage = walletItem:GetSmallImage();
			wItem.isAccountItem = walletItem:IsAccountItem();
			wItem.description = walletItem:GetDescription();
			table.insert(result.data.wallet, wItem);
		end
	end
	
	return result;
end

function BandOfFarmers:UpdateAndSavePlayerMessage(playerName, message)
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Message à sauvegarder pour "..playerName.." :\n"..message.."</rgb>");
	for i=1 , table.getn(self.playersData) , 1 do
		if(self.playersData[i].name == playerName) then
			self.playersData[i].message = message;
			DataSave(Turbine.DataScope.Account, "BandOfFarmers_characters", self.playersData);
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Message de "..playerName.." sauvegardé</rgb>");
		end
	end
end


function BandOfFarmers:GetName()
	return "BOF - Band Of Farmers";
end

function BandOfFarmers:IsRunning()
	return ( self ~= nil );
end

function BandOfFarmers:Start()
	if(self~=nil) then 
		self:SetVisible(true); 
	end
end

function BandOfFarmers:Stop()
	self = nil;
end

function sortdatabygold(player1,player2)
	if player1== nil or player2==nil then
		return true;
	end
	if (player1.data.gold > player2.data.gold) then
		return true
	end
end
